/****************************************************************************/
/**                       Beispielprogramm fr                             **/
/**                  die Windows PC-DLL WUSERML8.DLL                   	   **/
/**                           Version 1.A.                                 **/
/**                                                                        **/
/**			   Dateiname : WLEDDEMO.C		   	   **/
/**                 Erstellungsdatum : 14.12.1993                          **/
/**                  Letzte nderung : 24.04.1996 (MIH)                    **/
/**                           Status : freigegeben                         **/
/**                            Autor : G.Rudolf                            **/
/**                                                                        **/
/**  Anmerkung: Das Programm mu mit der Library WUSERML8.DLL und der	   **/
/**             Library WML8BIB.LIB gelinkt werden.                        **/
/**                                                                        **/
/**             (c) 1993..1996 SORCUS Computer GmbH  Heidelberg            **/
/**                                                                        **/
/****************************************************************************/
/*
*  Programmart: Windows-EXE Programm
*  Funktion: Beispielprogramm zum Laden eines Echtzeitprogramms
*  Programmiersprache: Borland C++ Version 3.1
*  Bibliotheksversion: ab ML8BIB 1.D und hher
*  Betriebssystemversion: ab ML8-2D.09 und hher
*  Verwendetes Echtzeitprogramm: -
*  Zugehrige Installationsdatei: -
*  Hardware-Voraussetzungen: MODULAR-4/486 Karte
*  Software-Voraussetzungen: Die Dateien WBLINK.C, WBLINK.DEF, WBLINK.RES,
*  			  M8P0300.EXE, WUSERML8.DLL und WML8BIB.DLL mssen
*  			  im aktuellen bzw. in dem im Code angegebenen
*			  Verzeichnis stehen.
*
*  Anmerkung: Dieses Beispiel zeigt wie das Echtzeitprogramm M8P0300.EXE auf die
*  	   MODULAR-4/486 Karte geladen wird.
*
*  Bedienung: Nach dem Starten wird die MODULAR-4/486 initialisiert, ggf. wird
*  	   ein Reset der MODULAR-4/486 durchgefhrt. Danach wird ein
*  	   Kontrollfenseter mit zwei 'Buttons' geffnet. Durch ansteuern
*  	   der Buttons mit der linken Maustaste kann das Echtzeitprogramm
*  	   gestartet (Start Button) bzw. gestoppt (Stopp Button) werden.
*  	   Der aktuelle Zustand des Programms wird durch ein 'Icon'
*  	   dargestellt.
*
*  Querverweis: WBLINK.C, WUSERML8.C
*****************************************************************************/
#define STRICT

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ml8bib.h>			/* MODULAR-4 Header-Datei */

#define ID_START_BUTTON	       200	/* ID Nummer Start-Knopf */
#define	ID_STOP_BUTTON         201	/* ID Nummer Stopp-Knopf */

#define PG_NAME      "\\sorcus\\ml8\\rt\\bc\\beisp\\M8P0300.EXE"
					/* Name des Echtzeitprogrammes*/
#define PG_NR        0x300              /* Nummer des Echtzeitprogrammes*/
#define PG_FLAG      0x0980             /* Installierungsflags des Echtz.pgms*/
#define PG_TASK      16	       		/* Tasknummer des Programms M8P0300 */

/*-------------------------------------------------------------------------*/
/**	Funktion aus der WUSERML8.DLL
/*-------------------------------------------------------------------------*/
extern BOOL far pascal GetStateML8(void);

/*-------------------------------------------------------------------------*/
/**	Funktionsdeklarationen
/*-------------------------------------------------------------------------*/
long FAR PASCAL _export MainWndProc(HWND, unsigned, WORD, LONG);
BOOL InitApplication(HINSTANCE);

/*-------------------------------------------------------------------------*/
/**	Globale Variablen
/*-------------------------------------------------------------------------*/
HINSTANCE hInst;			/* Instanz Variable */
HWND      hWnd;				/* Handle Mutterfenster */
HWND      hStartButton;			/* Handle Button 'Start' */
HWND      hStopButton;			/* Handle Button 'Stopp' */
HICON	  hLedOn;			/* Handle Icon 'Led eingeschaltet' */
HICON	  hLedOff;			/* Handle Icon 'Led ausgeschaltet' */
int	  merker_start_led;		/* Zustandsmerker der Programm-Start-Led */

/***************************************************************************/
/**  Programminitialisierung fr die erste Instanz des Programms
/***************************************************************************/
BOOL InitApplication( HINSTANCE hInstance )
{
   int	     control;				/* Ladekontrolle */
   char	     errstrg[256];			/* Fehlerstrting */
   WNDCLASS  wc;                                /* Fensterklasse */

   /*----------------------------------------------------------------------*/
   /**	MODULAR-4/486 ansprechbar ?
   /*----------------------------------------------------------------------*/
   if( GetStateML8() == FALSE ) {		/* Konnte die Bibliothek nicht geffnet werden, */
      return (FALSE);				/* so wird das Programm abgebrochen. */
   }

   /*----------------------------------------------------------------------*/
   /**  LED Blinkprogramm M8P0300.EXE lade
   /*----------------------------------------------------------------------*/
   /*--------------- Echtzeitprogramm laden und installieren ----------------*/
   control = ml8_transfer_and_install(
		PG_NAME,			/* Programmname */
		0,				/* USAGE, zZ. nur 0 erlaubt */
		PG_TASK,			/* Tasknummer */
		PG_NR,				/* Programmnummer */
		0,				/* Interruptnummer (0, da NI-Task)*/
		PG_FLAG,			/* Programmflags */
		0				/* Gre des Datenbereichs */
   );

   /*----------------------------------------------------------------------*/
   /**	Aufgetretener Fehler in der MessageBox anzeigen
   /*----------------------------------------------------------------------*/
   if( control != 0 ) {                   	/*Ladefehler?*/
      sprintf( errstrg, "Fehler beim Laden des Programmes %s\nFehlerklasse \t: %d\n Fehlercode \t: %d\n\n",
	       PG_NAME, control/128, control%128 );
      MessageBox( (HWND) NULL,
		  (LPSTR) errstrg,
		  (LPSTR) "Fehlermeldung der MODULAR-4/486",
		  MB_TASKMODAL|MB_ICONINFORMATION|MB_OK );
      return( FALSE );
   }

   /*----------------------------------------------------------------------*/
   /**	Laden der Resourcen-Icon
   /*----------------------------------------------------------------------*/
   hLedOn   	    = LoadIcon( hInstance, "led_on_icon" );
   hLedOff  	    = LoadIcon( hInstance, "led_off_icon" );

   /*----------------------------------------------------------------------*/
   /**	Fensterklassendefinition: Hauptfenster
   /*----------------------------------------------------------------------*/
   wc.style         = 0;				/* Stiel der Klasse */
   wc.lpfnWndProc   = (long (FAR PASCAL*)())MainWndProc;/* Zeiger auf Fensterfunktion */
   wc.cbClsExtra    = 0;	                        /* Anzahl Byte, die nach der Klasse reserviert werden */
   wc.cbWndExtra    = 0;	                        /* Anzahl Byte, die nach der Fensterinstanz reserviert werden */
   wc.hInstance     = hInstance;	                /* Handle der aktuellen Instanze */
   wc.hIcon         = LoadIcon( hInstance, "SORCUS_ICON" );/* Icon der Fensterklasse */
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);	/* Cursor der Fensterklasse */
   wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);	/* Hintergrundfarbe der Fensterklasse */
   wc.lpszMenuName  = NULL;                             /* Es wird kein Men verwendet */
   wc.lpszClassName = "LOAD_WND";	                /* Name der Fensterklasse */

   return( RegisterClass( &wc ) );			/* Klasse registrieren und Rcksprung */
}

/***************************************************************************/
/**  Programminitialisierung bei allen Instanzen
/***************************************************************************/
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
   /*----------------------------------------------------------------------*/
   /**	Hauptfenster erzeugen
   /*----------------------------------------------------------------------*/
   hWnd = CreateWindow(
		"LOAD_WND", 	                /* Zeiger auf den Namen der Fensterklasse */
		"LED Blinkprogramm",  		/* Zeiger auf den Titelleistentext */
		WS_EX_DLGMODALFRAME |
		WS_CAPTION |
		WS_SYSMENU,	                /* Stiel des Fensters */
		CW_USEDEFAULT, 			/* X Position der linken oberen Ecke des Fensters in Pixel */
		CW_USEDEFAULT,	   	   	/* Y Position der linken oberen Ecke des Fensters in Pixel */
		206,	      		        /* Breite des Fensters in Pixel */
		100, 		   	        /* Hhe des Fensters in Pixel */
		NULL,		   		/* Handle des bergeordneten Fensters */
		NULL,	   			/* Handle auf das Men des Fensters */
		hInstance,  			/* Handle der aktuellen Instanze */
		NULL			   	/* Zeiger auf frei definierbare Parameter*/
   );

   if (!hWnd)					/* Konnte das Fenster nicht erzeugt werden, */
      return (FALSE);				/* so wird das Programm abgebrochen. */

   /*----------------------------------------------------------------------*/
   /**	Start Knopf erzeugen
   /*----------------------------------------------------------------------*/
   hStartButton = CreateWindow(
		"BUTTON", 	                /* Zeiger auf den Namen der Fensterklasse */
		"Start",			/* Zeiger auf den Buttontext */
		WS_CHILD | WS_VISIBLE,          /* Stiel des Fensters */
		20, 				/* X Position der linken oberen Ecke des Fensters in Pixel */
		40,	   	   		/* Y Position der linken oberen Ecke des Fensters in Pixel */
		70,	      		        /* Breite des Fensters in Pixel */
		25, 		   	        /* Hhe des Fensters in Pixel */
		hWnd,		   		/* Handle des bergeordneten Fensters */
		(HMENU)ID_START_BUTTON,		/* ID Nummer des Buttons */
		hInstance,  			/* Handle der aktuellen Instanze */
		NULL			   	/* Zeiger auf frei definierbare Parameter*/
   );

   if ( !hStartButton ) {			/* Konnte der Knopf nicht erzeugt werden, */
      DestroyWindow( hWnd );			/* so wird das Programm abgebrochen und */
      return (FALSE);				/* alle geffneten Fenster zerstrt */
   }

   /*----------------------------------------------------------------------*/
   /**	Stopp Knopf erzeugen
   /*----------------------------------------------------------------------*/
   hStopButton = CreateWindow(
		"BUTTON", 	                /* Zeiger auf den Namen der Fensterklasse */
		"Stopp",			/* Zeiger auf den Buttontext */
		WS_CHILD | WS_VISIBLE,          /* Stiel des Fensters */
		110, 				/* X Position der linken oberen Ecke des Fensters in Pixel */
		40,	   	   		/* Y Position der linken oberen Ecke des Fensters in Pixel */
		70,	      		        /* Breite des Fensters in Pixel */
		25, 		   	        /* Hhe des Fensters in Pixel */
		hWnd,		   		/* Handle des bergeordneten Fensters */
		(HMENU)ID_STOP_BUTTON,		/* ID Nummer des Buttons */
		hInstance,  			/* Handle der aktuellen Instanze */
		NULL			   	/* Zeiger auf frei definierbare Parameter*/
   );

   if ( !hStopButton ) {			/* Konnte der Knopf nicht erzeugt werden, */
      DestroyWindow( hWnd );			/* so wird das Programm abgebrochen und */
      DestroyWindow( hStartButton );            /* alle geffneten Fenster zerstrt */
      return (FALSE);
   }

   ShowWindow(hWnd, nCmdShow);			/* Fenster anzeigen */
   UpdateWindow(hWnd);				/* WM_PAINT Message erzeugen */
   return (TRUE);
}


/***************************************************************************/
/**   MainWndProc(HWND, unsigned, WORD, LONG)
/***************************************************************************/
long FAR PASCAL _export MainWndProc( HWND hWnd, unsigned message,
			     WORD wParam, LONG lParam )
{
   HDC		hdc;				/* Ausgabekontext (DC) des Fensters */
   PAINTSTRUCT	ps;				/* Paintstruktur */

   switch( message ) {				/* Auswerten der empfangenen Message */

      case WM_PAINT:             		/* Fensterinhalt aktuallisieren */
	 BeginPaint( hWnd, &ps );		/* Paintstruktur holen */

	 if( merker_start_led == 1 )		/* Wenn der LED-Merker 1 ist, */
	    DrawIcon( ps.hdc, 12, 8, hLedOn);   /* so wird das Icon 'LedOn' ausgegeben */
	 else					/* Ansonsten wird das ICOn */
	    DrawIcon( ps.hdc, 12, 8, hLedOff); 	/* 'LedOff' ausgegeben */

	 TextOut( ps.hdc, 44, 16, "= Programm Zustand", 18 );

	 EndPaint( hWnd, &ps );			/* Paintsruktur zurckgeben */
	 break;

      case WM_COMMAND:				/* Message auswerten */
	 hdc = GetDC( hWnd );			/* Ausgabekontext (DC) des Fensters holen */
	 switch(wParam) {			/* wParam auswerten */
	    case ID_START_BUTTON:		/* ID des Lokalen Knopfs */
	       if( merker_start_led != 1 ) {		/* Ist der Merker ungleich 1, so */
		  merker_start_led = 1;			/* wird der Merker auf 1 gesetzt, */
		  ml8_call_proc( PG_TASK, 2 );		/* Blinkprogramm starten */
		  DrawIcon( hdc, 12, 8, hLedOn);        /* das Icon 'LedOn' angezeigt */
	       }
	       break;

	    case ID_STOP_BUTTON:		/* ID des Lokalen Knopfs */
	       if( merker_start_led == 1 ) {         	/* Ist der Merker gleich 1, so */
		  merker_start_led = 0;              	/* wird der Merker auf 0 gesetzt, */
		  ml8_call_proc( PG_TASK, 3 );		/* Blinkprogramm stoppen */
		  DrawIcon( hdc, 12, 8, hLedOff);       /* das Icon 'LedOff' angezeigt */
	       }
	       break;

	    default:
		break;
	}
	ReleaseDC( hWnd, hdc );			/* Ausgabekontext (DC) des Fensters zurckgeben */
	break;

      case WM_DESTROY:				/* Fenster wurde geschlossen */
	 PostQuitMessage( 0 );			/* WM_QUIT Besttigung zurckgeben */
	 break;

      default:
	 return( DefWindowProc( hWnd, message, wParam, lParam ));
   }

   return( NULL );
}

#pragma argsused
/***************************************************************************/
/**
/***************************************************************************/
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
		    LPSTR lpCmdLine, int nCmdShow)
{
   MSG 		msg;                    	/* Message */

   /*----------------------------------------------------------------------*/
   /* Variablen Initialisieren
   /*----------------------------------------------------------------------*/
   hInst 		= hInstance;	 	/* Sichern des Instanzhandles */
   merker_start_led  	= 0;			/* Globale LED-Merker fr intern LED */

   if( !hPrevInstance ) {			/* 1. Instanz */
      if( !InitApplication( hInstance) )	/* Initialisierungsprozedur aufrufen */
	 return (FALSE);			/* Exit bei Fehler */
   }
   else {					/* Kopieren der Daten aus der 1. Instance */
      hLedOn  = LoadIcon( hPrevInstance, "led_on_icon" );
      hLedOff = LoadIcon( hPrevInstance, "led_off_icon" );
   }

   if( !InitInstance( hInstance, nCmdShow ) )	/* Programminitialisierung bei allen */
      return (FALSE);				/* Instanzen */

   while( GetMessage( &msg, NULL, 0, 0 ) ) {
      TranslateMessage( &msg );			/* Translates virtual key codes */
      DispatchMessage( &msg );			/* Dispatches message to window */
   }

   return( msg.wParam );			/* Rckgabewert der PostQuitMessage */
}

