/****************************************************************************/
/**                       Beispielprogramm fr                             **/
/**                  die Windows PC-DLL WML8BIB.DLL                   	   **/
/**                           Version 1.A.                                 **/
/**                                                                        **/
/**			   Dateiname : WLEDDEMO.C		   	   **/
/**                 Erstellungsdatum : 14.12.1993                          **/
/**                  Letzte nderung : 24.04.1996 (MIH)                    **/
/**                           Status : freigegeben                         **/
/**                            Autor : G.Rudolf                            **/
/**                                                                        **/
/**  Anmerkung: Das Programm mu mit dem Programmmodul WLEDML8.C und der   **/
/**             Library WML8BIB.LIB gelinkt werden.                        **/
/**                                                                        **/
/**             (c) 1993..1996 SORCUS Computer GmbH  Heidelberg            **/
/**                                                                        **/
/****************************************************************************/
/*
*  Programmart: Windows-EXE Programm
*  Funktion: Beispielprogramm zur Steuerung der lokalen und externen LED
*  Programmiersprache: Borland C++ Version 3.1
*  Bibliotheksversion: ab ML8BIB 1.D und hher
*  Betriebssystemversion: ab ML8-2D.09  und hher
*  Verwendetes Echtzeitprogramm: -
*  Zugehrige Installationsdatei: -
*  Hardware-Voraussetzungen: MODULAR-4/486 Karte
*  Software-Voraussetzungen: Die Dateien WLEDDEMO.C, WLEDML8.C, WLEDDEMO.DEF,
*  			  WLEDDEMO.RES und die DLL WML8BIB.DLL mssen
*  			  im aktuellen Verzeichnis stehen.
*
*  Anmerkung: Dieses Beispiel zeigt wie die Dynamische Link Library 'WML8BIB.DLL'
*  	   in einem Windows-Programm verwendet werden kann.
*
*  Bedienung: Nach dem Starten wird die MODULAR-4/486 initialisiert, ggf. wird
*  	   ein Reset der MODULAR-4/486 durchgefhrt. Danach wird ein
*  	   Kontrollfenseter mit zwei 'Buttons' geffnet. Durch ansteuern
*  	   der Buttons mit der linken Maustaste kann die lokale bzw. die
*  	   externe LED ein und ausgeschaltet werden. Der aktuelle Zustand der
*  	   LED wird jeweils ber dem entsprechenden Button durch ein 'Icon'
*  	   dargestellt.
*
*  Querverweis: WLEDDEMO.C, WLEDML8.C
****************************************************************************/
#define STRICT

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ml8bib.h>			/* MODULAR-4 Header-Datei */

#define ID_LOCAL_BUTTON	       200	/* ID Nummer lokaler Knopf */
#define	ID_EXTERNAL_BUTTON     201	/* ID Nummer externen Knopf */

/*-------------------------------------------------------------------------*/
/**	Funktionsdeklarationen
/*-------------------------------------------------------------------------*/
long FAR PASCAL _export MainWndProc(HWND, unsigned, WORD, LONG);
BOOL InitApplication(HINSTANCE);
BOOL InitML8( void );

/*-------------------------------------------------------------------------*/
/**	Globale Variablen
/*-------------------------------------------------------------------------*/
HINSTANCE hInst;			/* Instanz Variable */
HWND      hWnd;				/* Handle Mutterfenster */
HWND      hLocalButton;			/* Handle Button 'Intern' */
HWND      hExternalButton;		/* Handle Button 'Extern' */
HICON	  hLedOn;			/* Handle Icon 'Led eingeschaltet' */
HICON	  hLedOff;			/* Handle Icon 'Led ausgeschaltet' */
int	  merker_local_led;		/* Zustandsmerker der lokalen Led */
int	  merker_external_led;		/* Zustandsmerker der externen Led */



/***************************************************************************/
/**  Programminitialisierung fr die erste Instanz des Programms
/***************************************************************************/
BOOL InitApplication( HINSTANCE hInstance )
{
   WNDCLASS  wc;

   /*----------------------------------------------------------------------*/
   /**	Initialisieren der MODULAR-4 Bibliothek
   /*----------------------------------------------------------------------*/
   if( InitML8() == FALSE ) {			/* Konnte die Bibliothek nicht geffnet werden, */
      return (FALSE);				/* so wird das Programm abgebrochen. */
   }

   /*----------------------------------------------------------------------*/
   /**	Laden der Resourcen-Icon
   /*----------------------------------------------------------------------*/
   hLedOn   	    = LoadIcon( hInstance, "led_on_icon" );
   hLedOff  	    = LoadIcon( hInstance, "led_off_icon" );

   /*----------------------------------------------------------------------*/
   /**	Fensterklassendefinition: Hauptfenster
   /*----------------------------------------------------------------------*/
   wc.style         = 0;				/* Stiel der Klasse */
   wc.lpfnWndProc   = (long (FAR PASCAL*)())MainWndProc;/* Zeiger auf Fensterfunktion */
   wc.cbClsExtra    = 0;	                        /* Anzahl Byte, die nach der Klasse reserviert werden */
   wc.cbWndExtra    = 0;	                        /* Anzahl Byte, die nach der Fensterinstanz reserviert werden */
   wc.hInstance     = hInstance;	                /* Handle der aktuellen Instanze */
   wc.hIcon         = LoadIcon( hInstance, "SORCUS_ICON" );/* Icon der Fensterklasse */
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);	/* Cursor der Fensterklasse */
   wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);	/* Hintergrundfarbe der Fensterklasse */
   wc.lpszMenuName  = NULL;                             /* Es wird kein Men verwendet */
   wc.lpszClassName = "LED_TEST";	                /* Name der Fensterklasse */

   return( RegisterClass( &wc ) );			/* Klasse registrieren und Rcksprung */
}

/***************************************************************************/
/**  Programminitialisierung bei allen Instanzen
/***************************************************************************/
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
   /*----------------------------------------------------------------------*/
   /**	Hauptfenster erzeugen
   /*----------------------------------------------------------------------*/
   hWnd = CreateWindow(
		"LED_TEST", 	                /* Zeiger auf den Namen der Fensterklasse */
		"Sorcus LED Test",		/* Zeiger auf den Titelleistentext */
		WS_EX_DLGMODALFRAME |
		WS_CAPTION |
		WS_SYSMENU,	                /* Stiel des Fensters */
		CW_USEDEFAULT, 			/* X Position der linken oberen Ecke des Fensters in Pixel */
		CW_USEDEFAULT,	   	   	/* Y Position der linken oberen Ecke des Fensters in Pixel */
		206,	      		        /* Breite des Fensters in Pixel */
		100, 		   	        /* Hhe des Fensters in Pixel */
		NULL,		   		/* Handle des bergeordneten Fensters */
		NULL,	   			/* Handle auf das Men des Fensters */
		hInstance,  			/* Handle der aktuellen Instanze */
		NULL			   	/* Zeiger auf frei definierbare Parameter*/
   );

   if (!hWnd)					/* Konnte das Fenster nicht erzeugt werden, */
      return (FALSE);				/* so wird das Programm abgebrochen. */

   /*----------------------------------------------------------------------*/
   /**	lokalen Knopf erzeugen
   /*----------------------------------------------------------------------*/
   hLocalButton = CreateWindow(
		"BUTTON", 	                /* Zeiger auf den Namen der Fensterklasse */
		"Intern",			/* Zeiger auf den Titelleistentext */
		WS_CHILD | WS_VISIBLE,          /* Stiel des Fensters */
		20, 				/* X Position der linken oberen Ecke des Fensters in Pixel */
		40,	   	   		/* Y Position der linken oberen Ecke des Fensters in Pixel */
		70,	      		        /* Breite des Fensters in Pixel */
		25, 		   	        /* Hhe des Fensters in Pixel */
		hWnd,		   		/* Handle des bergeordneten Fensters */
		(HMENU)ID_LOCAL_BUTTON,		/* ID Nummer des Buttons */
		hInstance,  			/* Handle der aktuellen Instanze */
		NULL			   	/* Zeiger auf frei definierbare Parameter*/
   );

   if ( !hLocalButton ) {			/* Konnte der Knopf nicht erzeugt werden, */
      DestroyWindow( hWnd );			/* so wird das Programm abgebrochen und */
      return (FALSE);				/* alle geffneten Fenster zerstrt */
   }


   /*----------------------------------------------------------------------*/
   /**	externen Knopf erzeugen
   /*----------------------------------------------------------------------*/
   hExternalButton = CreateWindow(
		"BUTTON", 	                /* Zeiger auf den Namen der Fensterklasse */
		"Extern",			/* Zeiger auf den Titelleistentext */
		WS_CHILD | WS_VISIBLE,          /* Stiel des Fensters */
		110, 				/* X Position der linken oberen Ecke des Fensters in Pixel */
		40,	   	   		/* Y Position der linken oberen Ecke des Fensters in Pixel */
		70,	      		        /* Breite des Fensters in Pixel */
		25, 		   	        /* Hhe des Fensters in Pixel */
		hWnd,		   		/* Handle des bergeordneten Fensters */
		(HMENU)ID_EXTERNAL_BUTTON,      /* ID Nummer des Buttons */
		hInstance,  			/* Handle der aktuellen Instanze */
		NULL			   	/* Zeiger auf frei definierbare Parameter*/
   );

   if ( !hExternalButton ) {			/* Konnte der Knopf nicht erzeugt werden, */
      DestroyWindow( hWnd );			/* so wird das Programm abgebrochen und */
      DestroyWindow( hLocalButton );            /* alle geffneten Fenster zerstrt */
      return (FALSE);
   }

   ShowWindow(hWnd, nCmdShow);			/* Fenster anzeigen */
   UpdateWindow(hWnd);				/* WM_PAINT Message erzeugen */
   return (TRUE);
}


/***************************************************************************/
/**   MainWndProc(HWND, unsigned, WORD, LONG)
/***************************************************************************/
long FAR PASCAL _export MainWndProc( HWND hWnd, unsigned message,
			     WORD wParam, LONG lParam )
{
   HDC		hdc;				/* Ausgabekontext (DC) des Fensters */
   PAINTSTRUCT	ps;				/* Paintstruktur */

   switch( message ) {				/* Auswerten der empfangenen Message */

      case WM_PAINT:             		/* Fensterinhalt aktuallisieren */
	 BeginPaint( hWnd, &ps );		/* Paintstruktur holen */

	 if( merker_local_led == 1 )		/* Wenn der lokele LED-Merker 1 ist, */
	    DrawIcon( ps.hdc, 39, 8, hLedOn);   /* so wird das Icon 'LedOn' ausgegeben */
	 else					/* Ansonsten wird das ICOn */
	    DrawIcon( ps.hdc, 39, 8, hLedOff); 	/* 'LedOff' ausgegeben */

	 if( merker_external_led == 1 )		/* Wenn der lokele LED-Merker 1 ist, */
	    DrawIcon( ps.hdc, 129, 8, hLedOn);  /* so wird das Icon 'LedOn' ausgegeben */
	 else					/* Ansonsten wird das ICOn */
	    DrawIcon( ps.hdc, 129, 8, hLedOff); /* 'LedOff' ausgegeben */

	 EndPaint( hWnd, &ps );			/* Paintsruktur zurckgeben */
	 break;

      case WM_COMMAND:				/* Message auswerten */
	 hdc = GetDC( hWnd );			/* Ausgabekontext (DC) des Fensters holen */
	 switch(wParam) {			/* wParam auswerten */
	    case ID_LOCAL_BUTTON:		/* ID des Lokalen Knopfs */
	       if( merker_local_led == 1 ) {		/* Ist der lokale Merker gleich 1, so */
		  merker_local_led = 0;			/* wird der lokale Merker auf 0 gesetzt, */
		  ml8_local_led_off();          	/* die lokale LED ausgeschaltet und */
		  DrawIcon( hdc, 39, 8, hLedOff);       /* das Icon 'LedOff' angezeigt */
	       }
	       else {                                   /* Andernfalls */
		  merker_local_led = 1;			/* wird der lokale Merker auf 1 gesetzt, */
		  ml8_local_led_on();          		/* die lokale LED eingeschaltet und */
		  DrawIcon( hdc, 39, 8, hLedOn);        /* das Icon 'LedOn' angezeigt */
	       }
	       break;

	    case ID_EXTERNAL_BUTTON:	  	/* ID des Lokalen Knopfs */
	       if( merker_external_led == 1 ) {         /* Ist der externe Merker gleich 1, so */
		  merker_external_led = 0;              /* wird der externe Merker auf 0 gesetzt, */
		  ml8_external_led_off();               /* die externe LED ausgeschaltet und */
		  DrawIcon( hdc, 129, 8, hLedOff);      /* das Icon 'LedOff' angezeigt */
		}
		else {                                  /* Andernfalls */
		  merker_external_led = 1;              /* wird der externe Merker auf 1 gesetzt, */
		  ml8_external_led_on();                /* die externe LED eingeschaltet und */
		  DrawIcon( hdc, 129, 8, hLedOn);       /* das Icon 'LedOn' angezeigt */
		}
		break;

	    default:
		break;
	}
	ReleaseDC( hWnd, hdc );			/* Ausgabekontext (DC) des Fensters zurckgeben */
	break;

      case WM_DESTROY:				/* Fenster wurde geschlossen */
	 ml8_local_led_off();		        /* Lokale LED ausschalten */
	 ml8_external_led_off();		/* Externe LED ausschalten */
	 ml8_exit();				/* MODULAR-4 Bibliothek schlieen */
	 PostQuitMessage( 0 );			/* WM_QUIT Besttigung zurckgeben */
	 break;

      default:
	 return( DefWindowProc( hWnd, message, wParam, lParam ));
   }

   return( NULL );
}


#pragma argsused
/***************************************************************************/
/**
/***************************************************************************/
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
		    LPSTR lpCmdLine, int nCmdShow)
{
   MSG 		msg;                    	/* Message */

   /*----------------------------------------------------------------------*/
   /* Variablen Initialisieren
   /*----------------------------------------------------------------------*/
   hInst 		= hInstance;	 	/* Sichern des Instanzhandles */
   merker_local_led  	= 0;			/* Globale LED-Merker fr intern LED */
   merker_external_led  = 0;			/* und extern LED mit 0 initialisieren */

   if( !hPrevInstance ) {			/* 1. Instanz */
      if( !InitApplication( hInstance) )	/* Initialisierungsprozedur aufrufen */
	 return (FALSE);			/* Exit bei Fehler */
   }
   else {					/* Es darf immer nur ein Programm mit der */
      return (FALSE);				/* Karte kommunizieren. Sollen mehrere Programme */
   }						/* mit einer Karte arbeiten, so mu eine 'Lade' DLL */
						/* generiert werden. Siehe dazu das Beispiel 'WDLLDEMO' */

   if( !InitInstance( hInstance, nCmdShow ) )	/* Programminitialisierung bei allen */
      return (FALSE);				/* Instanzen */

   while( GetMessage( &msg, NULL, 0, 0 ) ) {
      TranslateMessage( &msg );			/* Translates virtual key codes */
      DispatchMessage( &msg );			/* Dispatches message to window */
   }

   return( msg.wParam );			/* Rckgabewert der PostQuitMessage */
}

