/****************************************************************************/
/**                        Programmmodul fr                               **/
/**                         fr WMLEDDEMO.C                                **/
/**                           Version 1.A.                                 **/
/**                                                                        **/
/**			   Dateiname : WLEDML8.C		   	   **/
/**                 Erstellungsdatum : 14.12.1993                          **/
/**                  Letzte nderung : 07.02.1994                          **/
/**                           Status : freigegeben                         **/
/**                            Autor : G.Rudolf                            **/
/**                                                                        **/
/**  Anmerkung: Das Programm WLEDML8.C mu zu dem Programm WLEDDEMO.C      **/
/**             gelinkt werden.                                            **/
/**                                                                        **/
/**             (c) 1993 SORCUS Computer GmbH  Heidelberg                  **/
/**                                                                        **/
/****************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <ml8bib.h>

#define CARD_NUMBER  0			      	/* Kartennummer */
#define OS_NAME	     "ROM"      		/* Suchpfad zum Betriebssystem und
						   dessen Namen */

extern far HWND      hWnd;		   	/* Handle des Hauptfensters */

ERROR_PROC   ErrorHandler;   			/* Fehlerbehandlungsroutine der MODULAR-4 Bibliothek */
SERVICE_PROC IRQHandler;			/* Interruptroutine der MODULAR-4 Bibliothek */


/****************************************************************************/
/**  Diese Funktion installiert die Echtzeitprogramme fr den
/**  Modul-Device-Treiber auf einer MODULAR-4/486 Karte
/****************************************************************************/
BOOL InitML8( void )
{
   unsigned int	 status;			/* Zustand der Karte */
   unsigned char reacting;			/* Reaktionstest der Karte */
   unsigned char reset;				/* Reset Merker */
   char		 error_message[256];		/* Fehlermeldung */
   unsigned char os;				/* Betriebssytembezeichnung */

   reset = FALSE;
   ml8_bib_startup( 0x0200 );			/* Sprache C anwhlen */

   /*----------------------------------------------------------------------*/
   /**	Reset der MODULAR-4 Karte durchfhren und initialisieren
   /*----------------------------------------------------------------------*/
   status = ml8_start(
		CARD_NUMBER,			/* Kartennummer */
		0x380,				/* Basisadresse der Karte */
		0,				/* Mode 0, kein Interrupt und DMA Betrieb */
		0,				/* Interruptnummer, wird bei Mode 0 nicht bentigt */
		0,				/* DMA-Kanal, wird bei Mode 0 nicht bentigt */
		(ERROR_PROC_P) ErrorHandler, 	/* Adresse der Fehlerbehandlungsroutine */
		10				/* Timeoutzeit fr die Kommunikation PC<->MODULAR-4 */
   );

   reacting = ml8_reacting();
   if( (status != 0) ||				/* Karte lt sich nicht ansprechen */
       (reacting != 1) ) {
      sprintf( error_message, "Fehlerklasse \t: %d\n Fehlercode \t: %d\n\n",
	       (status>>8), (status&0x00FF) );
      ml8_get_error_message( &error_message[strlen(error_message)] );
      strcat( error_message, "\n\nInitialisierung der Kommunikation PC-MODULAR-4/486 mit Reset");
      MessageBox( (HWND) NULL,
		  (LPSTR) error_message,
		  (LPSTR) "Fehlermeldung der MODULAR-4/486",
		  MB_TASKMODAL|MB_ICONINFORMATION|MB_OK|MB_SYSTEMMODAL );
      reset = TRUE;
   }

   if( (os == 0) || 				/* bei 0 = ROM-MINI, ROM-Betriebssystem laden */
       (reset == TRUE) ) {			/* Es mu ein Reset durgefhrt werden */
      status = ml8_reset(
		CARD_NUMBER,			/* Kartennummer */
		0x380,				/* Basisadresse der Karte */
		0,				/* Mode 0, kein Interrupt und DMA Betrieb */
		0,				/* Interruptnummer, wird bei Mode 0 nicht bentigt */
		0,				/* DMA-Kanal, wird bei Mode 0 nicht bentigt */
		(ERROR_PROC_P) ErrorHandler, 	/* Adresse der Fehlerbehandlungsroutine */
		OS_NAME,			/* Pfad und Name des Betriebssystems */
		10				/* Timeoutzeit fr die Kommunikation PC<->MODULAR-4 */
      );

      reacting = ml8_reacting();
      if( (status != 0) ||			/* Karte lt sich nicht ansprechen */
	  (reacting != 1) ) {
	 sprintf( error_message, "Fehlerklasse \t: %d\n Fehlercode \t: %d\n\n",
		  (status>>8), (status&0x00FF) );
	 ml8_get_error_message( &error_message[strlen(error_message)] );
	 strcat( error_message, "\n\nDas Programm wird angehalten");
	 MessageBox( (HWND) NULL,
		     (LPSTR) error_message,
		     (LPSTR) "Fehlermeldung der MODULAR-4/486",
		     MB_TASKMODAL|MB_ICONINFORMATION|MB_OK|MB_SYSTEMMODAL );
	 ml8_exit();				/* MODULAR-4 Bibliothek schlieen */
	 return( FALSE );			/* Programmabbruch */
      }
   }

   ml8_local_led_off();				/* Lokale LED ausschalten */
   ml8_external_led_off();			/* Externe LED ausschalten */

   return( TRUE );				/* Alles OK */
}


/***************************************************************************/
/**   Fehlerbehandlungsroutine
/**   Anmerkung: Diese Funktion mu Callback fhig sein, da sie von der DLL
/**		 WML8BIB.DLL aufgerufen wird. Dies wird durch die
/**		 Definition mit ERROR_PROC und der Compilereinstellung
/**		 'Windows: alle Funktionen exportierbar' oder
/**		 'Windows: explizite Funktionen exportierbar' erreicht.
/**		 Menpfad: Optionen/Compiler/Entry-/Exitcode
/***************************************************************************/
ERROR_PROC ErrorHandler
{
   struct ml8_error_info_type 	error_info;	/* Fehlerstruktur */
   unsigned int 		message;	/* Message */
   char				string[256];	/* Ausgabestring */

   ml8_get_error_info( &error_info );		/* Fehlerstruktur fllen */

   /*----------------------------------------------------------------------*/
   /**	Fehler Request der Modular-4 Karte
   /*----------------------------------------------------------------------*/
   if( error_info.errorclass == 5 ) {
      message = ml8_get_message();
      sprintf( string, "Error Request der MODULAR-4/486 Karte : %d",
	       message );
   }

   /*----------------------------------------------------------------------*/
   /**	Ist ein Fehler aufgetreten ?
   /*----------------------------------------------------------------------*/
   if( error_info.ok ) {                     	/* Es ist kein Fehler aufgetreten */
      sprintf( string, "Es liegt keine Fehlermeldung vor.");
   }

   /*----------------------------------------------------------------------*/
   /**	Fehlerklasse und Fehlercode auslesen
   /*----------------------------------------------------------------------*/
   if( (error_info.errorclass != 5) &&
       !(error_info.ok) ) {
      sprintf( string, "Fehlerklasse \t: %d\n Fehlercode \t: %d\n\n",
	       error_info.errorclass, error_info.errorcode );
      ml8_get_error_message( &string[strlen(string)] );
   }

   /*----------------------------------------------------------------------*/
   /**	Aufgetretener Fehler in der MessageBox anzeigen
   /*----------------------------------------------------------------------*/
   MessageBox( (HWND) hWnd,
	       (LPSTR) string,
	       (LPSTR) "Fehlermeldung der MODULAR-4/486",
	       MB_TASKMODAL|MB_ICONINFORMATION|MB_OK );
}


/***************************************************************************/
/**  Service-Request Routine
/**   Anmerkung: Diese Funktion mu Callback fhig sein, da sie von der DLL
/**		 WML8BIB.DLL aufgerufen wird. Dies wird durch die
/**		 Definition mit SERVICE_PROC und der Compilereinstellung
/**		 'Windows: alle Funktionen exportierbar' oder
/**		 'Windows: explizite Funktionen exportierbar' erreicht.
/**		 Menpfad: Optionen/Compiler/Entry-/Exitcode
/***************************************************************************/
SERVICE_PROC IRQHandler
{
   /*----------------------------------------------------------------------*/
   /**	Aufgetretener Service-Request in der MessageBox anzeigen
   /*----------------------------------------------------------------------*/
   MessageBox( (HWND) hWnd,
	       (LPSTR) ml8_get_message(),
	       (LPSTR) "Service-Request",
	       MB_TASKMODAL|MB_ICONINFORMATION|MB_OK );
}
